// Alien Crime Lord

local ACL = {}

if rawget(_G, "ACL") then
	return
end

function ACL:InTable(Table, Value, Index)
	for i,v in pairs(Table) do
		if Value and v == Value then
			return i,v
		end
		if Index and i == Index then
			return i,v
		end
	end
	return nil
end

function ACL:Lerp(a, b, t)
    return a + (b - a) * t
end

function ACL:IsPlayerActionable(player)
	if player
	and player.valid
	and player.playerstate == PST_LIVE
	and player.mo
	and player.mo.valid
	--and player.mo.state ~= S_PLAY_PAIN then
		return true
	end
	return false
end

function ACL:IsActionable(mo)
	if mo
	and mo.valid
	and mo.state ~= S_PLAY_PAIN
	and mo.state ~= S_PLAY_DEAD
	and mo.state ~= S_PLAY_DRWN then
		return true
	end
	return false
end

function ACL:CheckHeight(tmthing,thing)
	if tmthing.z <= thing.z+thing.height and tmthing.z+tmthing.height >= thing.z then
		return true
	end
	return false
end

rawset(_G, "ACL", ACL)

for i,v in pairs(ACL) do
	if type(v) == "function" and not rawget(_G, "ACL_" .. i) then
		rawset(_G, "ACL_" .. i, function(self, ...)
			v(...)
		end)
	end
end